import { ElementDeclarationNode, SyntaxNode } from '../../../parser/nodes';
import { ArgumentBinderRule, SettingListBinderRule } from '../types';
import { CompileError } from '../../../errors';
export default abstract class ElementBinder {
    protected abstract subfield: {
        arg: ArgumentBinderRule;
        settingList: SettingListBinderRule;
    };
    protected abstract settingList: SettingListBinderRule;
    private errors;
    private declarationNode;
    constructor(declarationNode: ElementDeclarationNode, errors: CompileError[]);
    bind(): void;
    private bindSettingList;
    private bindBody;
    private bindSubfield;
    private scanAndBind;
    private bindFragments;
    private resolveIndexStack;
    protected logError(node: SyntaxNode, message: string, ignoreError: boolean): void;
}
