import { default as SymbolFactory } from '../../symbol/factory';
import { CompileError } from '../../../errors';
import { BlockExpressionNode, ElementDeclarationNode, FunctionApplicationNode } from '../../../parser/nodes';
import { SyntaxToken } from '../../../lexer/tokens';
import { ElementValidator } from '../types';
import { default as SymbolTable } from '../../symbol/symbolTable';
export default class NoteValidator implements ElementValidator {
    private declarationNode;
    private publicSymbolTable;
    private symbolFactory;
    constructor(declarationNode: ElementDeclarationNode & {
        type: SyntaxToken;
    }, publicSymbolTable: SymbolTable, symbolFactory: SymbolFactory);
    validate(): CompileError[];
    private validateContext;
    private validateName;
    private validateAlias;
    private validateSettingList;
    validateBody(body?: FunctionApplicationNode | BlockExpressionNode): CompileError[];
    validateFields(fields: FunctionApplicationNode[]): CompileError[];
    private validateSubElements;
}
