/*
 * Copyright (c) 2015-2024 Snowflake Computing Inc. All rights reserved.
 */

// 400001
exports[400001] = 'An internal error has occurred. Please contact Snowflake support.';
exports[400002] = 'You are using an unsupported version of Node.js. Please use %s or above.';

// 401001
exports[401001] = 'Network error. Could not reach Snowflake.';
exports[401002] = 'Request to Snowflake failed.';
exports[401003] = 'Snowflake responded with non-JSON content.';
exports[401004] = 'Request to Snowflake failed.  Invalid token';

// 402001
exports[402001] = 'Network error. Could not reach S3/Blob.';
exports[402002] = 'Request to S3/Blob failed.';

// 403001
exports[403001] = 'Invalid logLevel. The specified value must be one of these five levels: error, warn, debug, info and trace.';
exports[403002] = 'Invalid insecureConnect option. The specified value must be a boolean.';
exports[403003] = 'Invalid OCSP mode. The specified value must be FAIL_CLOSED, FAIL_OPEN, or INSECURE_MODE.';
exports[403004] = 'Invalid custom JSON parser. The specified value must be a function.';
exports[403005] = 'Invalid custom XML parser. The specified value must be a function.';
exports[403006] = 'Invalid keep alive value. The specified value must be a boolean.';
exports[403007] = 'Invalid custom credential manager value. The specified value must be an object, and it should have three methods: write, read, remove';

// 404001
exports[404001] = 'Connection options must be specified.';
exports[404002] = 'Invalid connection options. The specified value must be an object.';
exports[404003] = 'A user name must be specified.';
exports[404004] = 'Invalid user name. The specified value must be a string.';
exports[404005] = 'A password must be specified.';
exports[404006] = 'Invalid password. The specified value must be a string.';
exports[404007] = 'An account must be specified.';
exports[404008] = 'Invalid account. The specified value must be a string.';
exports[404009] = 'An accessUrl must be specified.';
exports[404010] = 'Invalid accessUrl. The specified value must be a string.';
exports[404011] = 'Invalid warehouse. The specified value must be a string.';
exports[404012] = 'Invalid database. The specified value must be a string.';
exports[404013] = 'Invalid schema. The specified value must be a string.';
exports[404014] = 'Invalid role. The specified value must be a string.';
exports[404015] = 'A proxyHost must be specified';
exports[404016] = 'Invalid proxyHost. The specified value must be a string.';
exports[404017] = 'A proxyPort must be specified.';
exports[404018] = 'Invalid proxyPort. The specified value must be a number.';
exports[404019] = 'Invalid streamResult flag. The specified value must be a boolean.';
exports[404020] = 'Invalid fetchAsString option. The specified value must be an Array.';
exports[404021] = 'Invalid fetchAsString type: %s. The supported types are: String, Boolean, Number, Date, Buffer, and JSON.';
exports[404022] = 'Invalid region. The specified value must be a string.';
exports[404023] = 'Invalid clientSessionKeepAlive. The specified value must be a boolean.';
exports[404024] = 'Invalid clientSessionKeepAliveHeartbeatFrequency. The specified value must be a number.';
exports[404025] = 'Invalid jsTreatIntegerAsBigInt. The specified value must be a boolean';
exports[404026] = 'Invalid private key. The specified value must be a string in pem format of type pkcs8';
exports[404027] = 'Invalid private key file location. The specified value must be a string';
exports[404028] = 'Invalid private key passphrase. The specified value must be a string';
exports[404029] = 'Invalid oauth token. The specified value must be a string';
exports[404030] = 'Invalid validate default parameters value. The specified value must be a boolean';
exports[404031] = 'Invalid application value. The specified value must be a string that starts with a letter and a length between 1-50';
exports[404032] = 'A proxyUser must be specified';
exports[404033] = 'Invalid proxyUser. The specified value must be a string.';
exports[404034] = 'A proxyPassword must be specified.';
exports[404035] = 'Invalid proxyPassword. The specified value must be a string.';
exports[404036] = 'Invalid noProxy. The specified value must be a string.';
exports[404037] = 'Invalid arrayBindingThreshold. The specified value must be a number.';
exports[404038] = 'Invalid gcsUseDownscopedCredential. The specified value must be a boolean.';
exports[404039] = 'Invalid forceStageBindError. The specified value must be a number.';
exports[404040] = 'Invalid browser timeout value. The specified value must be a positive number.';
exports[404041] = 'Invalid disableQueryContextCache. The specified value must be a boolean.';
exports[404042] = 'Invalid includeRetryReason. The specified value must be a boolean.';
exports[404043] = 'Invalid clientConfigFile value. The specified value must be a string.';
exports[404044] = 'Invalid retryTimeout value. The specified value must be a number.';
exports[404045] = 'Invalid account. The specified value must be a valid subdomain string.';
exports[404046] = 'Invalid region. The specified value must be a valid subdomain string.';
exports[404047] = 'Invalid disableConsoleLogin. The specified value must be a boolean';
exports[404048] = 'Invalid disableGCPTokenUpload. The specified value must be a boolean';
exports[404048] = 'Invalid forceGCPUseDownscopedCredential. The specified value must be a boolean';
exports[404049] = 'Invalid clientStoreTemporaryCredential. The specified value must be a boolean.';
exports[404050] = 'Invalid representNullAsStringNull. The specified value must be a boolean';
exports[404051] = 'Invalid disableSamlURLCheck. The specified value must be a boolean';
exports[404052] = 'Invalid clientRequestMFAToken. The specified value must be a boolean.';
exports[404053] = 'A host must be specified.';
exports[404054] = 'Invalid host. The specified value must be a string.';
exports[404055] = 'Invalid passcodeInPassword. The specified value must be a boolean';
exports[404056] = 'Invalid passcode. The specified value must be a string';

// 405001
exports[405001] = 'Invalid callback. The specified value must be a function.';

// 405501
exports[405501] = 'Connection already in progress.';
exports[405502] = 'Already connected.';
exports[405503] = 'Connection already terminated. Cannot connect again.';
exports[405504] = 'connect() does not work with external browser or okta authenticators, call connectAsync() instead';
exports[405505] = 'Configuration from client config file failed';

// 406001
exports[406001] = 'Invalid callback. The specified value must be a function.';

// 406501
exports[406501] = 'Not connected, so nothing to destroy.';
exports[406502] = 'Already disconnected.';

// 407001
exports[407001] = 'Unable to perform operation because a connection was never established.';
exports[407002] = 'Unable to perform operation using terminated connection.';

// 408001
exports[408001] = 'A serializedConnection must be specified.';
exports[408002] = 'Invalid serializedConnection. The specified value must be a string.';
exports[408003] = 'Invalid serializedConnection. The value must be a string obtained by calling another connection\'s serialize() method.';

// 409001
exports[409001] = 'Execute options must be specified.';
exports[409002] = 'Invalid execute options. The specified value must be an object.';
exports[409003] = 'A sqlText value must be specified.';
exports[409004] = 'Invalid sqlText. The specified value must be a string.';
exports[409005] = 'Invalid internal flag. The specified value must be a boolean.';
exports[409006] = 'Invalid parameters. The specified value must be an object.';
exports[409007] = 'Invalid binds. The specified value must be an array.';
exports[409008] = 'Invalid bind variable: %s. Only stringifiable values are supported.';
exports[409009] = 'Invalid complete callback. The specified value must be a function.';
exports[409010] = 'Invalid streamResult flag. The specified value must be a boolean.';
exports[409011] = 'Invalid fetchAsString value. The specified value must be an Array.';
exports[409012] = 'Invalid fetchAsString type: %s. The supported types are: String, Boolean, Number, Date, Buffer, and JSON.';
exports[409013] = 'Invalid requestId. The specified value must be a string.';
exports[409014] = 'Invalid asyncExec. The specified value must be a boolean.';

// 410001
exports[410001] = 'Fetch-result options must be specified.';
exports[410002] = 'Invalid options. The specified value must be an object.';
exports[410003] = 'A query id/statement id must be specified.';
exports[410004] = 'Invalid query id/statement id. The specified value must be a string.';
exports[410005] = 'Invalid complete callback. The specified value must be a function.';
exports[410006] = 'Invalid streamResult flag. The specified value must be a boolean.';
exports[410007] = 'Invalid fetchAsString value. The specified value must be an Array.';
exports[410008] = 'Invalid fetchAsString type: %s. The supported types are: String, Boolean, Number, Date, Buffer, and JSON.';
exports[410009] = 'Invalid cwd (current working directory) type: %s. The specified value must be a string.';

// 411001
exports[411001] = 'Invalid options. The specified value must be an object.';
exports[411002] = 'Invalid start index. The specified value must be a number.';
exports[411003] = 'Invalid end index. The specified value must be a number.';
exports[411004] = 'Invalid fetchAsString value. The specified value must be an Array.';
exports[411005] = 'Invalid fetchAsString type: %s. The supported types are: String, Boolean, Number, Date, Buffer, and JSON.';
exports[411006] = 'Invalid row mode value. The specified value should be array or object or object_with_renamed_duplicated_columns';

exports[412001] = 'Certificate is REVOKED.';
exports[412002] = 'Certificate status is UNKNOWN.';
exports[412003] = 'Not recognize signature algorithm.';
exports[412004] = 'Invalid signature.';
exports[412005] = 'No OCSP response data is attached.';
exports[412006] = 'Invalid validity.';
exports[412007] = 'Could not verify the certificate revocation status.';
exports[412008] = 'Not two elements are in the cache.';
exports[412009] = 'Cache entry expired.';
exports[412010] = 'Failed to parse OCSP response.';
exports[412011] = 'Invalid Signing Certificate validity.';
exports[412012] = 'Timeout OCSP responder.';
exports[412013] = 'Timeout OCSP Cache server.';
exports[412014] = 'Failed to obtain OCSP response: %s';

// 450001
exports[450001] = 'Fetch-row options must be specified.';
exports[450002] = 'Invalid options. The specified value must be an object.';
exports[450003] = 'An each() callback must be specified.';
exports[450004] = 'Invalid each() callback. The specified value must be a function.';
exports[450005] = 'An end() callback must be specified.';
exports[450006] = 'Invalid end() callback. The specified value must be a function.';
exports[450007] = 'Operation failed because the statement is still in progress.';

// 460001
exports[460001] = 'Invalid queryId: %s';
exports[460002] = 'Cannot retrieve data. No information returned from server for query %s';
exports[460003] = 'Status of query %s is %s, results are unavailable';
